package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.psychological.utils.Constant;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * @author zsy
 * @description:信任量表
 * @date 2021/7/20 15:55
 */
public class TSScale extends BaseScale{

    public TSScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }

    public  JSONObject scaleCalculate() throws Exception {
        //总得分
        int score = 0;
        //可预测性得分
        int score1 = 0;
        //依靠性得分
        int score2 = 0;
        //信赖得分
        int score3 = 0;
        for (int i = 0; i < jsonArray.size(); i++) {
            JSONObject jsonObject1 = jsonArray.getJSONObject(i);
            if (jsonObject1.getString("scoreDirection").equals("1")) {
                if (i == 0 || i == 2 || i == 7 || i == 10 || i == 12 || i == 17) {
                    if (jsonObject1.getString("checkItems").equals("完全不同意")) {
                        score1 += 1;
                    } else if (jsonObject1.getString("checkItems").equals("部分不同意")) {
                        score1 += 2;
                    } else if (jsonObject1.getString("checkItems").equals("略微不同意")) {
                        score1 += 3;
                    } else if (jsonObject1.getString("checkItems").equals("中性")) {
                        score1 += 4;
                    } else if (jsonObject1.getString("checkItems").equals("略微同意")) {
                        score1 += 5;
                    } else if (jsonObject1.getString("checkItems").equals("部分同意")) {
                        score1 += 6;
                    } else if (jsonObject1.getString("checkItems").equals("完全同意")) {
                        score1 += 7;
                    }
                } else if (i == 1 || i == 4 || i == 6 || i == 8 || i == 14 || i == 16) {
                    if (jsonObject1.getString("checkItems").equals("完全不同意")) {
                        score2 += 1;
                    } else if (jsonObject1.getString("checkItems").equals("部分不同意")) {
                        score2 += 2;
                    } else if (jsonObject1.getString("checkItems").equals("略微不同意")) {
                        score2 += 3;
                    } else if (jsonObject1.getString("checkItems").equals("中性")) {
                        score2 += 4;
                    } else if (jsonObject1.getString("checkItems").equals("略微同意")) {
                        score2 += 5;
                    } else if (jsonObject1.getString("checkItems").equals("部分同意")) {
                        score2 += 6;
                    } else if (jsonObject1.getString("checkItems").equals("完全同意")) {
                        score2 += 7;
                    }
                } else {
                    if (jsonObject1.getString("checkItems").equals("完全不同意")) {
                        score3 += 1;
                    } else if (jsonObject1.getString("checkItems").equals("部分不同意")) {
                        score3 += 2;
                    } else if (jsonObject1.getString("checkItems").equals("略微不同意")) {
                        score3 += 3;
                    } else if (jsonObject1.getString("checkItems").equals("中性")) {
                        score3 += 4;
                    } else if (jsonObject1.getString("checkItems").equals("略微同意")) {
                        score3 += 5;
                    } else if (jsonObject1.getString("checkItems").equals("部分同意")) {
                        score3 += 6;
                    } else if (jsonObject1.getString("checkItems").equals("完全同意")) {
                        score3 += 7;
                    }
                }
            } else {
                if (i == 0 || i == 2 || i == 7 || i == 10 || i == 12 || i == 17) {
                    if (jsonObject1.getString("checkItems").equals("完全不同意")) {
                        score1 += 7;
                    } else if (jsonObject1.getString("checkItems").equals("部分不同意")) {
                        score1 += 6;
                    } else if (jsonObject1.getString("checkItems").equals("略微不同意")) {
                        score1 += 5;
                    } else if (jsonObject1.getString("checkItems").equals("中性")) {
                        score1 += 4;
                    } else if (jsonObject1.getString("checkItems").equals("略微同意")) {
                        score1 += 3;
                    } else if (jsonObject1.getString("checkItems").equals("部分同意")) {
                        score1 += 2;
                    } else if (jsonObject1.getString("checkItems").equals("完全同意")) {
                        score1 += 1;
                    }
                } else if (i == 1 || i == 4 || i == 6 || i == 8 || i == 14 || i == 16) {
                    if (jsonObject1.getString("checkItems").equals("完全不同意")) {
                        score2 += 7;
                    } else if (jsonObject1.getString("checkItems").equals("部分不同意")) {
                        score2 += 6;
                    } else if (jsonObject1.getString("checkItems").equals("略微不同意")) {
                        score2 += 5;
                    } else if (jsonObject1.getString("checkItems").equals("中性")) {
                        score2 += 4;
                    } else if (jsonObject1.getString("checkItems").equals("略微同意")) {
                        score2 += 3;
                    } else if (jsonObject1.getString("checkItems").equals("部分同意")) {
                        score2 += 2;
                    } else if (jsonObject1.getString("checkItems").equals("完全同意")) {
                        score2 += 1;
                    }
                } else {
                    if (jsonObject1.getString("checkItems").equals("完全不同意")) {
                        score3 += 7;
                    } else if (jsonObject1.getString("checkItems").equals("部分不同意")) {
                        score3 += 6;
                    } else if (jsonObject1.getString("checkItems").equals("略微不同意")) {
                        score3 += 5;
                    } else if (jsonObject1.getString("checkItems").equals("中性")) {
                        score3 += 4;
                    } else if (jsonObject1.getString("checkItems").equals("略微同意")) {
                        score3 += 3;
                    } else if (jsonObject1.getString("checkItems").equals("部分同意")) {
                        score3 += 2;
                    } else if (jsonObject1.getString("checkItems").equals("完全同意")) {
                        score3 += 1;
                    }
                }
            }
        }
        score += score1 + score2 + score3;
        //得分列表
        Map<String, String> resultMap = new LinkedHashMap<>();
        resultMap.put("总分", String.valueOf(score));
        resultJson.put("总分", String.valueOf(score));
        resultMap.put("可预测性得分", String.valueOf(score1));
        resultJson.put("可预测性得分", String.valueOf(score1));
        resultMap.put("依靠性得分", String.valueOf(score2));
        resultJson.put("依靠性得分", String.valueOf(score2));
        resultMap.put("信赖得分", String.valueOf(score3));
        resultJson.put("信赖得分", String.valueOf(score3));

        List<Map<String,String>> resultMapList = new ArrayList<>();
        resultMapList.add(resultMap);

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList",resultMapList);
        returnJson.put("scaleName",Constant.SHEET_NAME_TS);
        returnJson.put("resultJson",resultJson);

        return returnJson;
    }
}
